"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bindingsHelper = void 0;
var BindingsHelper = (function () {
    function BindingsHelper() {
        this.schemaObjectKeys = [
            'http.query',
            'kafka.groupId',
            'kafka.clientId',
            'kafka.key',
            'ws.headers',
            'ws.query',
        ];
    }
    BindingsHelper.prototype.isSchemaObject = function (context, bindingType) {
        return this.schemaObjectKeys.includes("".concat(bindingType, ".").concat(context));
    };
    BindingsHelper.prototype.isObject = function (value) {
        return !!value && typeof value === 'object';
    };
    return BindingsHelper;
}());
exports.bindingsHelper = new BindingsHelper();
//# sourceMappingURL=bindingsHelpers.js.map